


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/krb5/types.py: 52%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/krb5/types.py</b> :
            <span class="pc_cov">52%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            172 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">102 run</span>
            <span class="mis shortkey_m button_toggle_mis">70 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">12 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="pln"><a href="#n20">20</a></p>
<p id="n21" class="pln"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="pln"><a href="#n23">23</a></p>
<p id="n24" class="pln"><a href="#n24">24</a></p>
<p id="n25" class="pln"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="stm run hide_run"><a href="#n30">30</a></p>
<p id="n31" class="pln"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="pln"><a href="#n33">33</a></p>
<p id="n34" class="stm run hide_run"><a href="#n34">34</a></p>
<p id="n35" class="stm run hide_run"><a href="#n35">35</a></p>
<p id="n36" class="pln"><a href="#n36">36</a></p>
<p id="n37" class="pln"><a href="#n37">37</a></p>
<p id="n38" class="stm run hide_run"><a href="#n38">38</a></p>
<p id="n39" class="stm run hide_run"><a href="#n39">39</a></p>
<p id="n40" class="pln"><a href="#n40">40</a></p>
<p id="n41" class="stm run hide_run"><a href="#n41">41</a></p>
<p id="n42" class="stm par run hide_run"><a href="#n42">42</a></p>
<p id="n43" class="stm mis"><a href="#n43">43</a></p>
<p id="n44" class="stm mis"><a href="#n44">44</a></p>
<p id="n45" class="stm mis"><a href="#n45">45</a></p>
<p id="n46" class="stm run hide_run"><a href="#n46">46</a></p>
<p id="n47" class="pln"><a href="#n47">47</a></p>
<p id="n48" class="pln"><a href="#n48">48</a></p>
<p id="n49" class="pln"><a href="#n49">49</a></p>
<p id="n50" class="stm run hide_run"><a href="#n50">50</a></p>
<p id="n51" class="pln"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="pln"><a href="#n53">53</a></p>
<p id="n54" class="pln"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="pln"><a href="#n56">56</a></p>
<p id="n57" class="pln"><a href="#n57">57</a></p>
<p id="n58" class="stm run hide_run"><a href="#n58">58</a></p>
<p id="n59" class="stm run hide_run"><a href="#n59">59</a></p>
<p id="n60" class="stm run hide_run"><a href="#n60">60</a></p>
<p id="n61" class="stm run hide_run"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="stm run hide_run"><a href="#n63">63</a></p>
<p id="n64" class="stm run hide_run"><a href="#n64">64</a></p>
<p id="n65" class="pln"><a href="#n65">65</a></p>
<p id="n66" class="stm run hide_run"><a href="#n66">66</a></p>
<p id="n67" class="stm par run hide_run"><a href="#n67">67</a></p>
<p id="n68" class="stm mis"><a href="#n68">68</a></p>
<p id="n69" class="stm run hide_run"><a href="#n69">69</a></p>
<p id="n70" class="stm par run hide_run"><a href="#n70">70</a></p>
<p id="n71" class="stm mis"><a href="#n71">71</a></p>
<p id="n72" class="pln"><a href="#n72">72</a></p>
<p id="n73" class="stm par run hide_run"><a href="#n73">73</a></p>
<p id="n74" class="stm mis"><a href="#n74">74</a></p>
<p id="n75" class="stm mis"><a href="#n75">75</a></p>
<p id="n76" class="stm mis"><a href="#n76">76</a></p>
<p id="n77" class="stm par run hide_run"><a href="#n77">77</a></p>
<p id="n78" class="stm run hide_run"><a href="#n78">78</a></p>
<p id="n79" class="stm par run hide_run"><a href="#n79">79</a></p>
<p id="n80" class="stm mis"><a href="#n80">80</a></p>
<p id="n81" class="pln"><a href="#n81">81</a></p>
<p id="n82" class="stm run hide_run"><a href="#n82">82</a></p>
<p id="n83" class="stm run hide_run"><a href="#n83">83</a></p>
<p id="n84" class="pln"><a href="#n84">84</a></p>
<p id="n85" class="stm par run hide_run"><a href="#n85">85</a></p>
<p id="n86" class="stm mis"><a href="#n86">86</a></p>
<p id="n87" class="pln"><a href="#n87">87</a></p>
<p id="n88" class="stm run hide_run"><a href="#n88">88</a></p>
<p id="n89" class="pln"><a href="#n89">89</a></p>
<p id="n90" class="stm run hide_run"><a href="#n90">90</a></p>
<p id="n91" class="pln"><a href="#n91">91</a></p>
<p id="n92" class="pln"><a href="#n92">92</a></p>
<p id="n93" class="stm mis"><a href="#n93">93</a></p>
<p id="n94" class="stm mis"><a href="#n94">94</a></p>
<p id="n95" class="stm mis"><a href="#n95">95</a></p>
<p id="n96" class="stm mis"><a href="#n96">96</a></p>
<p id="n97" class="stm mis"><a href="#n97">97</a></p>
<p id="n98" class="stm mis"><a href="#n98">98</a></p>
<p id="n99" class="stm mis"><a href="#n99">99</a></p>
<p id="n100" class="stm mis"><a href="#n100">100</a></p>
<p id="n101" class="pln"><a href="#n101">101</a></p>
<p id="n102" class="stm mis"><a href="#n102">102</a></p>
<p id="n103" class="pln"><a href="#n103">103</a></p>
<p id="n104" class="stm par run hide_run"><a href="#n104">104</a></p>
<p id="n105" class="stm run hide_run"><a href="#n105">105</a></p>
<p id="n106" class="pln"><a href="#n106">106</a></p>
<p id="n107" class="stm run hide_run"><a href="#n107">107</a></p>
<p id="n108" class="stm mis"><a href="#n108">108</a></p>
<p id="n109" class="stm mis"><a href="#n109">109</a></p>
<p id="n110" class="pln"><a href="#n110">110</a></p>
<p id="n111" class="stm mis"><a href="#n111">111</a></p>
<p id="n112" class="pln"><a href="#n112">112</a></p>
<p id="n113" class="pln"><a href="#n113">113</a></p>
<p id="n114" class="pln"><a href="#n114">114</a></p>
<p id="n115" class="pln"><a href="#n115">115</a></p>
<p id="n116" class="stm run hide_run"><a href="#n116">116</a></p>
<p id="n117" class="stm mis"><a href="#n117">117</a></p>
<p id="n118" class="stm mis"><a href="#n118">118</a></p>
<p id="n119" class="pln"><a href="#n119">119</a></p>
<p id="n120" class="stm mis"><a href="#n120">120</a></p>
<p id="n121" class="stm mis"><a href="#n121">121</a></p>
<p id="n122" class="stm mis"><a href="#n122">122</a></p>
<p id="n123" class="pln"><a href="#n123">123</a></p>
<p id="n124" class="stm mis"><a href="#n124">124</a></p>
<p id="n125" class="pln"><a href="#n125">125</a></p>
<p id="n126" class="stm run hide_run"><a href="#n126">126</a></p>
<p id="n127" class="stm mis"><a href="#n127">127</a></p>
<p id="n128" class="pln"><a href="#n128">128</a></p>
<p id="n129" class="pln"><a href="#n129">129</a></p>
<p id="n130" class="stm run hide_run"><a href="#n130">130</a></p>
<p id="n131" class="stm run hide_run"><a href="#n131">131</a></p>
<p id="n132" class="stm run hide_run"><a href="#n132">132</a></p>
<p id="n133" class="pln"><a href="#n133">133</a></p>
<p id="n134" class="stm run hide_run"><a href="#n134">134</a></p>
<p id="n135" class="pln"><a href="#n135">135</a></p>
<p id="n136" class="stm run hide_run"><a href="#n136">136</a></p>
<p id="n137" class="stm run hide_run"><a href="#n137">137</a></p>
<p id="n138" class="pln"><a href="#n138">138</a></p>
<p id="n139" class="stm run hide_run"><a href="#n139">139</a></p>
<p id="n140" class="stm run hide_run"><a href="#n140">140</a></p>
<p id="n141" class="stm run hide_run"><a href="#n141">141</a></p>
<p id="n142" class="pln"><a href="#n142">142</a></p>
<p id="n143" class="stm run hide_run"><a href="#n143">143</a></p>
<p id="n144" class="stm run hide_run"><a href="#n144">144</a></p>
<p id="n145" class="pln"><a href="#n145">145</a></p>
<p id="n146" class="stm run hide_run"><a href="#n146">146</a></p>
<p id="n147" class="pln"><a href="#n147">147</a></p>
<p id="n148" class="stm run hide_run"><a href="#n148">148</a></p>
<p id="n149" class="stm run hide_run"><a href="#n149">149</a></p>
<p id="n150" class="stm run hide_run"><a href="#n150">150</a></p>
<p id="n151" class="pln"><a href="#n151">151</a></p>
<p id="n152" class="stm run hide_run"><a href="#n152">152</a></p>
<p id="n153" class="stm mis"><a href="#n153">153</a></p>
<p id="n154" class="stm mis"><a href="#n154">154</a></p>
<p id="n155" class="pln"><a href="#n155">155</a></p>
<p id="n156" class="stm run hide_run"><a href="#n156">156</a></p>
<p id="n157" class="stm mis"><a href="#n157">157</a></p>
<p id="n158" class="pln"><a href="#n158">158</a></p>
<p id="n159" class="stm mis"><a href="#n159">159</a></p>
<p id="n160" class="stm mis"><a href="#n160">160</a></p>
<p id="n161" class="pln"><a href="#n161">161</a></p>
<p id="n162" class="stm mis"><a href="#n162">162</a></p>
<p id="n163" class="pln"><a href="#n163">163</a></p>
<p id="n164" class="stm run hide_run"><a href="#n164">164</a></p>
<p id="n165" class="pln"><a href="#n165">165</a></p>
<p id="n166" class="stm mis"><a href="#n166">166</a></p>
<p id="n167" class="stm mis"><a href="#n167">167</a></p>
<p id="n168" class="stm mis"><a href="#n168">168</a></p>
<p id="n169" class="stm mis"><a href="#n169">169</a></p>
<p id="n170" class="pln"><a href="#n170">170</a></p>
<p id="n171" class="stm mis"><a href="#n171">171</a></p>
<p id="n172" class="pln"><a href="#n172">172</a></p>
<p id="n173" class="stm run hide_run"><a href="#n173">173</a></p>
<p id="n174" class="pln"><a href="#n174">174</a></p>
<p id="n175" class="stm mis"><a href="#n175">175</a></p>
<p id="n176" class="stm mis"><a href="#n176">176</a></p>
<p id="n177" class="stm mis"><a href="#n177">177</a></p>
<p id="n178" class="stm mis"><a href="#n178">178</a></p>
<p id="n179" class="pln"><a href="#n179">179</a></p>
<p id="n180" class="stm mis"><a href="#n180">180</a></p>
<p id="n181" class="pln"><a href="#n181">181</a></p>
<p id="n182" class="stm run hide_run"><a href="#n182">182</a></p>
<p id="n183" class="pln"><a href="#n183">183</a></p>
<p id="n184" class="stm mis"><a href="#n184">184</a></p>
<p id="n185" class="pln"><a href="#n185">185</a></p>
<p id="n186" class="stm run hide_run"><a href="#n186">186</a></p>
<p id="n187" class="stm run hide_run"><a href="#n187">187</a></p>
<p id="n188" class="stm run hide_run"><a href="#n188">188</a></p>
<p id="n189" class="stm run hide_run"><a href="#n189">189</a></p>
<p id="n190" class="stm run hide_run"><a href="#n190">190</a></p>
<p id="n191" class="pln"><a href="#n191">191</a></p>
<p id="n192" class="stm run hide_run"><a href="#n192">192</a></p>
<p id="n193" class="stm run hide_run"><a href="#n193">193</a></p>
<p id="n194" class="stm run hide_run"><a href="#n194">194</a></p>
<p id="n195" class="stm run hide_run"><a href="#n195">195</a></p>
<p id="n196" class="stm par run hide_run"><a href="#n196">196</a></p>
<p id="n197" class="stm mis"><a href="#n197">197</a></p>
<p id="n198" class="pln"><a href="#n198">198</a></p>
<p id="n199" class="stm run hide_run"><a href="#n199">199</a></p>
<p id="n200" class="stm run hide_run"><a href="#n200">200</a></p>
<p id="n201" class="stm run hide_run"><a href="#n201">201</a></p>
<p id="n202" class="pln"><a href="#n202">202</a></p>
<p id="n203" class="stm run hide_run"><a href="#n203">203</a></p>
<p id="n204" class="stm run hide_run"><a href="#n204">204</a></p>
<p id="n205" class="stm par run hide_run"><a href="#n205">205</a></p>
<p id="n206" class="stm run hide_run"><a href="#n206">206</a></p>
<p id="n207" class="stm run hide_run"><a href="#n207">207</a></p>
<p id="n208" class="stm run hide_run"><a href="#n208">208</a></p>
<p id="n209" class="pln"><a href="#n209">209</a></p>
<p id="n210" class="stm run hide_run"><a href="#n210">210</a></p>
<p id="n211" class="stm run hide_run"><a href="#n211">211</a></p>
<p id="n212" class="pln"><a href="#n212">212</a></p>
<p id="n213" class="pln"><a href="#n213">213</a></p>
<p id="n214" class="stm run hide_run"><a href="#n214">214</a></p>
<p id="n215" class="stm run hide_run"><a href="#n215">215</a></p>
<p id="n216" class="stm run hide_run"><a href="#n216">216</a></p>
<p id="n217" class="pln"><a href="#n217">217</a></p>
<p id="n218" class="stm run hide_run"><a href="#n218">218</a></p>
<p id="n219" class="stm run hide_run"><a href="#n219">219</a></p>
<p id="n220" class="stm run hide_run"><a href="#n220">220</a></p>
<p id="n221" class="stm run hide_run"><a href="#n221">221</a></p>
<p id="n222" class="stm run hide_run"><a href="#n222">222</a></p>
<p id="n223" class="stm run hide_run"><a href="#n223">223</a></p>
<p id="n224" class="stm run hide_run"><a href="#n224">224</a></p>
<p id="n225" class="stm run hide_run"><a href="#n225">225</a></p>
<p id="n226" class="pln"><a href="#n226">226</a></p>
<p id="n227" class="stm run hide_run"><a href="#n227">227</a></p>
<p id="n228" class="stm run hide_run"><a href="#n228">228</a></p>
<p id="n229" class="stm run hide_run"><a href="#n229">229</a></p>
<p id="n230" class="stm run hide_run"><a href="#n230">230</a></p>
<p id="n231" class="pln"><a href="#n231">231</a></p>
<p id="n232" class="stm run hide_run"><a href="#n232">232</a></p>
<p id="n233" class="stm run hide_run"><a href="#n233">233</a></p>
<p id="n234" class="pln"><a href="#n234">234</a></p>
<p id="n235" class="stm run hide_run"><a href="#n235">235</a></p>
<p id="n236" class="stm mis"><a href="#n236">236</a></p>
<p id="n237" class="pln"><a href="#n237">237</a></p>
<p id="n238" class="stm run hide_run"><a href="#n238">238</a></p>
<p id="n239" class="stm run hide_run"><a href="#n239">239</a></p>
<p id="n240" class="pln"><a href="#n240">240</a></p>
<p id="n241" class="stm run hide_run"><a href="#n241">241</a></p>
<p id="n242" class="pln"><a href="#n242">242</a></p>
<p id="n243" class="pln"><a href="#n243">243</a></p>
<p id="n244" class="pln"><a href="#n244">244</a></p>
<p id="n245" class="pln"><a href="#n245">245</a></p>
<p id="n246" class="stm run hide_run"><a href="#n246">246</a></p>
<p id="n247" class="pln"><a href="#n247">247</a></p>
<p id="n248" class="stm run hide_run"><a href="#n248">248</a></p>
<p id="n249" class="pln"><a href="#n249">249</a></p>
<p id="n250" class="stm mis"><a href="#n250">250</a></p>
<p id="n251" class="stm mis"><a href="#n251">251</a></p>
<p id="n252" class="stm mis"><a href="#n252">252</a></p>
<p id="n253" class="stm mis"><a href="#n253">253</a></p>
<p id="n254" class="stm mis"><a href="#n254">254</a></p>
<p id="n255" class="stm mis"><a href="#n255">255</a></p>
<p id="n256" class="stm mis"><a href="#n256">256</a></p>
<p id="n257" class="stm mis"><a href="#n257">257</a></p>
<p id="n258" class="stm mis"><a href="#n258">258</a></p>
<p id="n259" class="stm mis"><a href="#n259">259</a></p>
<p id="n260" class="pln"><a href="#n260">260</a></p>
<p id="n261" class="stm par run hide_run"><a href="#n261">261</a></p>
<p id="n262" class="pln"><a href="#n262">262</a></p>
<p id="n263" class="stm mis"><a href="#n263">263</a></p>
<p id="n264" class="stm mis"><a href="#n264">264</a></p>
<p id="n265" class="stm mis"><a href="#n265">265</a></p>
<p id="n266" class="stm mis"><a href="#n266">266</a></p>
<p id="n267" class="stm mis"><a href="#n267">267</a></p>
<p id="n268" class="stm mis"><a href="#n268">268</a></p>
<p id="n269" class="stm mis"><a href="#n269">269</a></p>
<p id="n270" class="stm mis"><a href="#n270">270</a></p>
<p id="n271" class="stm mis"><a href="#n271">271</a></p>
<p id="n272" class="stm mis"><a href="#n272">272</a></p>
<p id="n273" class="stm mis"><a href="#n273">273</a></p>
<p id="n274" class="stm mis"><a href="#n274">274</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># Copyright (c) 2013, Marc Horowitz</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com"># All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># Redistribution and use in source and binary forms, with or without</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># modification, are permitted provided that the following conditions are</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com"># met:</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com"># Redistributions of source code must retain the above copyright notice,</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># this list of conditions and the following disclaimer.</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com"># Redistributions in binary form must reproduce the above copyright</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com"># notice, this list of conditions and the following disclaimer in the</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com"># documentation and/or other materials provided with the distribution.</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com"># THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com"># "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="com"># LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln"><span class="com"># A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln"><span class="com"># HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="pln"><span class="com"># SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="pln"><span class="com"># LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="com"># DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="pln"><span class="com"># THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="pln"><span class="com"># (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="pln"><span class="com"># OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run"><span class="key">import</span> <span class="nam">datetime</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run"><span class="key">import</span> <span class="nam">socket</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run"><span class="key">import</span> <span class="nam">re</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm run hide_run"><span class="key">import</span> <span class="nam">struct</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run"><span class="key">from</span> <span class="nam">pyasn1</span><span class="op">.</span><span class="nam">codec</span><span class="op">.</span><span class="nam">der</span> <span class="key">import</span> <span class="nam">decoder</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm run hide_run"><span class="key">from</span> <span class="op">.</span> <span class="key">import</span> <span class="nam">asn1</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm run hide_run"><span class="key">from</span> <span class="op">.</span> <span class="key">import</span> <span class="nam">constants</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t37" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm run hide_run"><span class="key">class</span> <span class="nam">KerberosException</span><span class="op">(</span><span class="nam">Exception</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm run hide_run">    <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm run hide_run"><span class="key">def</span> <span class="nam">_asn1_decode</span><span class="op">(</span><span class="nam">data</span><span class="op">,</span> <span class="nam">asn1Spec</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm par run hide_run"><span class="annotate short">42&#x202F;&#x219B;&#x202F;43</span><span class="annotate long">line 42 didn't jump to line 43, because the condition on line 42 was never true</span>    <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">data</span><span class="op">,</span> <span class="nam">str</span><span class="op">)</span> <span class="key">or</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">data</span><span class="op">,</span><span class="nam">bytes</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm mis">        <span class="nam">data</span><span class="op">,</span> <span class="nam">substrate</span> <span class="op">=</span> <span class="nam">decoder</span><span class="op">.</span><span class="nam">decode</span><span class="op">(</span><span class="nam">data</span><span class="op">,</span> <span class="nam">asn1Spec</span><span class="op">=</span><span class="nam">asn1Spec</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm mis">        <span class="key">if</span> <span class="nam">substrate</span> <span class="op">!=</span> <span class="str">b''</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm mis">            <span class="key">raise</span> <span class="nam">KerberosException</span><span class="op">(</span><span class="str">"asn1 encoding invalid"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm run hide_run">    <span class="key">return</span> <span class="nam">data</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t48" class="pln"><span class="com"># A principal can be represented as:</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm run hide_run"><span class="key">class</span> <span class="nam">Principal</span><span class="op">(</span><span class="nam">object</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="pln">    <span class="str">"""The principal's value can be supplied as:</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln"><span class="str">* a single string</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="pln"><span class="str">* a sequence containing a sequence of component strings and a realm string</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="pln"><span class="str">* a sequence whose first n-1 elemeents are component strings and whose last</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln"><span class="str">  component is the realm</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t57" class="pln"><span class="str">If the value contains no realm, then default_realm will be used."""</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">value</span><span class="op">=</span><span class="key">None</span><span class="op">,</span> <span class="nam">default_realm</span><span class="op">=</span><span class="key">None</span><span class="op">,</span> <span class="nam">type</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">=</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">PrincipalNameType</span><span class="op">.</span><span class="nam">NT_UNKNOWN</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">components</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm run hide_run">        <span class="key">if</span> <span class="nam">value</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm run hide_run">            <span class="key">return</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm run hide_run">        <span class="key">try</span><span class="op">:</span>               <span class="com"># Python 2</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm par run hide_run"><span class="annotate short">67&#x202F;&#x219B;&#x202F;68,&nbsp;&nbsp; 67&#x202F;&#x219B;&#x202F;73</span><span class="annotate long">2 missed branches: 1) line 67 didn't jump to line 68, because the condition on line 67 was never true, 2) line 67 didn't jump to line 73, because the condition on line 67 was never false</span>            <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">value</span><span class="op">,</span> <span class="nam">unicode</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm mis">                <span class="nam">value</span> <span class="op">=</span> <span class="nam">value</span><span class="op">.</span><span class="nam">encode</span><span class="op">(</span><span class="str">'utf-8'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm run hide_run">        <span class="key">except</span> <span class="nam">NameError</span><span class="op">:</span>  <span class="com"># Python 3</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="stm par run hide_run"><span class="annotate short">70&#x202F;&#x219B;&#x202F;71</span><span class="annotate long">line 70 didn't jump to line 71, because the condition on line 70 was never true</span>            <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">value</span><span class="op">,</span> <span class="nam">bytes</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm mis">                <span class="nam">value</span> <span class="op">=</span> <span class="nam">value</span><span class="op">.</span><span class="nam">decode</span><span class="op">(</span><span class="str">'utf-8'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm par run hide_run"><span class="annotate short">73&#x202F;&#x219B;&#x202F;74</span><span class="annotate long">line 73 didn't jump to line 74, because the condition on line 73 was never true</span>        <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">value</span><span class="op">,</span> <span class="nam">Principal</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">=</span> <span class="nam">value</span><span class="op">.</span><span class="nam">type</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">components</span> <span class="op">=</span> <span class="nam">value</span><span class="op">.</span><span class="nam">components</span><span class="op">[</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span> <span class="op">=</span> <span class="nam">value</span><span class="op">.</span><span class="nam">realm</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm par run hide_run"><span class="annotate short">77&#x202F;&#x219B;&#x202F;93</span><span class="annotate long">line 77 didn't jump to line 93, because the condition on line 77 was never false</span>        <span class="key">elif</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">value</span><span class="op">,</span> <span class="nam">str</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="stm run hide_run">            <span class="nam">m</span> <span class="op">=</span> <span class="nam">re</span><span class="op">.</span><span class="nam">match</span><span class="op">(</span><span class="str">r'((?:[^\\]|\\.)+?)(@((?:[^\\@]|\\.)+))?$'</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="stm par run hide_run"><span class="annotate short">79&#x202F;&#x219B;&#x202F;80</span><span class="annotate long">line 79 didn't jump to line 80, because the condition on line 79 was never true</span>            <span class="key">if</span> <span class="key">not</span> <span class="nam">m</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="stm mis">                <span class="key">raise</span> <span class="nam">KerberosException</span><span class="op">(</span><span class="str">"invalid principal syntax"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm run hide_run">            <span class="key">def</span> <span class="nam">unquote_component</span><span class="op">(</span><span class="nam">comp</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="stm run hide_run">                <span class="key">return</span> <span class="nam">re</span><span class="op">.</span><span class="nam">sub</span><span class="op">(</span><span class="str">r'\\(.)'</span><span class="op">,</span> <span class="str">r'\1'</span><span class="op">,</span> <span class="nam">comp</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t85" class="stm par run hide_run"><span class="annotate short">85&#x202F;&#x219B;&#x202F;86</span><span class="annotate long">line 85 didn't jump to line 86, because the condition on line 85 was never true</span>            <span class="key">if</span> <span class="nam">m</span><span class="op">.</span><span class="nam">group</span><span class="op">(</span><span class="num">2</span><span class="op">)</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span> <span class="op">=</span> <span class="nam">unquote_component</span><span class="op">(</span><span class="nam">m</span><span class="op">.</span><span class="nam">group</span><span class="op">(</span><span class="num">3</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="stm run hide_run">                <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span> <span class="op">=</span> <span class="nam">default_realm</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t90" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">components</span> <span class="op">=</span> <span class="op">[</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="pln">                <span class="nam">unquote_component</span><span class="op">(</span><span class="nam">qc</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="pln">                <span class="key">for</span> <span class="nam">qc</span> <span class="key">in</span> <span class="nam">re</span><span class="op">.</span><span class="nam">findall</span><span class="op">(</span><span class="str">r'(?:[^\\/]|\\.)+'</span><span class="op">,</span> <span class="nam">m</span><span class="op">.</span><span class="nam">group</span><span class="op">(</span><span class="num">1</span><span class="op">)</span><span class="op">)</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="stm mis">        <span class="key">elif</span> <span class="nam">len</span><span class="op">(</span><span class="nam">value</span><span class="op">)</span> <span class="op">==</span> <span class="num">2</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">components</span> <span class="op">=</span> <span class="nam">value</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span> <span class="op">=</span> <span class="nam">value</span><span class="op">[</span><span class="op">-</span><span class="num">1</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="stm mis">            <span class="key">if</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">components</span><span class="op">,</span> <span class="nam">str</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="stm mis">                <span class="nam">self</span><span class="op">.</span><span class="nam">components</span> <span class="op">=</span> <span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">components</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="stm mis">        <span class="key">elif</span> <span class="nam">len</span><span class="op">(</span><span class="nam">value</span><span class="op">)</span> <span class="op">>=</span> <span class="num">2</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">components</span> <span class="op">=</span> <span class="nam">value</span><span class="op">[</span><span class="num">0</span><span class="op">:</span><span class="op">-</span><span class="num">1</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span> <span class="op">=</span> <span class="nam">value</span><span class="op">[</span><span class="op">-</span><span class="num">1</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t101" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm mis">            <span class="key">raise</span> <span class="nam">KerberosException</span><span class="op">(</span><span class="str">"invalid principal value"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t104" class="stm par run hide_run"><span class="annotate short">104&#x202F;&#x219B;&#x202F;exit</span><span class="annotate long">line 104 didn't return from function '__init__', because the condition on line 104 was never false</span>        <span class="key">if</span> <span class="nam">type</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">=</span> <span class="nam">type</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t107" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__eq__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">other</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm mis">        <span class="key">if</span> <span class="nam">isinstance</span> <span class="op">(</span><span class="nam">other</span><span class="op">,</span> <span class="nam">str</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="stm mis">            <span class="nam">other</span> <span class="op">=</span> <span class="nam">Principal</span> <span class="op">(</span><span class="nam">other</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t111" class="stm mis">        <span class="key">return</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">==</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">PrincipalNameType</span><span class="op">.</span><span class="nam">NT_UNKNOWN</span><span class="op">.</span><span class="nam">value</span> <span class="key">or</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="pln">                <span class="nam">other</span><span class="op">.</span><span class="nam">type</span> <span class="op">==</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">PrincipalNameType</span><span class="op">.</span><span class="nam">NT_UNKNOWN</span><span class="op">.</span><span class="nam">value</span> <span class="key">or</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="pln">                <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">==</span> <span class="nam">other</span><span class="op">.</span><span class="nam">type</span><span class="op">)</span> <span class="key">and</span> <span class="nam">all</span> <span class="op">(</span><span class="nam">map</span> <span class="op">(</span><span class="key">lambda</span> <span class="nam">a</span><span class="op">,</span> <span class="nam">b</span><span class="op">:</span> <span class="nam">a</span> <span class="op">==</span> <span class="nam">b</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">components</span><span class="op">,</span> <span class="nam">other</span><span class="op">.</span><span class="nam">components</span><span class="op">)</span><span class="op">)</span> <span class="key">and</span> <span class="xx">\</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="pln">               <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span> <span class="op">==</span> <span class="nam">other</span><span class="op">.</span><span class="nam">realm</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t116" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__str__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm mis">        <span class="key">def</span> <span class="nam">quote_component</span><span class="op">(</span><span class="nam">comp</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="stm mis">            <span class="key">return</span> <span class="nam">re</span><span class="op">.</span><span class="nam">sub</span><span class="op">(</span><span class="str">r'([\\/@])'</span><span class="op">,</span> <span class="str">r'\\\1'</span><span class="op">,</span> <span class="nam">comp</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm mis">        <span class="nam">ret</span> <span class="op">=</span> <span class="str">"/"</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="op">[</span><span class="nam">quote_component</span><span class="op">(</span><span class="nam">c</span><span class="op">)</span> <span class="key">for</span> <span class="nam">c</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">components</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="stm mis">        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="stm mis">            <span class="nam">ret</span> <span class="op">+=</span> <span class="str">"@"</span> <span class="op">+</span> <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t124" class="stm mis">        <span class="key">return</span> <span class="nam">ret</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t126" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__repr__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="stm mis">        <span class="key">return</span> <span class="str">"Principal(("</span> <span class="op">+</span> <span class="nam">repr</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">components</span><span class="op">)</span> <span class="op">+</span> <span class="str">", "</span> <span class="op">+</span> <span class="xx">\</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="pln">               <span class="nam">repr</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">realm</span><span class="op">)</span> <span class="op">+</span> <span class="str">"), t="</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">type</span><span class="op">)</span> <span class="op">+</span> <span class="str">")"</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t130" class="stm run hide_run">    <span class="key">def</span> <span class="nam">from_asn1</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">,</span> <span class="nam">realm_component</span><span class="op">,</span> <span class="nam">name_component</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t131" class="stm run hide_run">        <span class="nam">name</span> <span class="op">=</span> <span class="nam">data</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="nam">name_component</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">=</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">PrincipalNameType</span><span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="pln">            <span class="nam">name</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="str">'name-type'</span><span class="op">)</span><span class="op">)</span><span class="op">.</span><span class="nam">value</span><span class="strut">&nbsp;</span></p>
<p id="t134" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">components</span> <span class="op">=</span> <span class="op">[</span><span class="strut">&nbsp;</span></p>
<p id="t135" class="pln">            <span class="nam">str</span><span class="op">(</span><span class="nam">c</span><span class="op">)</span> <span class="key">for</span> <span class="nam">c</span> <span class="key">in</span> <span class="nam">name</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="str">'name-string'</span><span class="op">)</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t136" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">realm</span> <span class="op">=</span> <span class="nam">str</span><span class="op">(</span><span class="nam">data</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="nam">realm_component</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t139" class="stm run hide_run">    <span class="key">def</span> <span class="nam">components_to_asn1</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">name</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t140" class="stm run hide_run">        <span class="nam">name</span><span class="op">.</span><span class="nam">setComponentByName</span><span class="op">(</span><span class="str">'name-type'</span><span class="op">,</span> <span class="nam">int</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">type</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t141" class="stm run hide_run">        <span class="nam">strings</span> <span class="op">=</span> <span class="nam">name</span><span class="op">.</span><span class="nam">setComponentByName</span><span class="op">(</span><span class="str">'name-string'</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="pln">                                          <span class="op">)</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="str">'name-string'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="stm run hide_run">        <span class="key">for</span> <span class="nam">i</span><span class="op">,</span> <span class="nam">c</span> <span class="key">in</span> <span class="nam">enumerate</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">components</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t144" class="stm run hide_run">            <span class="nam">strings</span><span class="op">.</span><span class="nam">setComponentByPosition</span><span class="op">(</span><span class="nam">i</span><span class="op">,</span> <span class="nam">c</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t145" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t146" class="stm run hide_run">        <span class="key">return</span> <span class="nam">name</span><span class="strut">&nbsp;</span></p>
<p id="t147" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t148" class="stm run hide_run"><span class="key">class</span> <span class="nam">Address</span><span class="op">(</span><span class="nam">object</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="stm run hide_run">    <span class="nam">DIRECTIONAL_AP_REQ_SENDER</span> <span class="op">=</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'!I'</span><span class="op">,</span> <span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t150" class="stm run hide_run">    <span class="nam">DIRECTIONAL_AP_REQ_RECIPIENT</span> <span class="op">=</span> <span class="nam">struct</span><span class="op">.</span><span class="nam">pack</span><span class="op">(</span><span class="str">'!I'</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t151" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t152" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t154" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">data</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t155" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t156" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__str__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t157" class="stm mis">        <span class="nam">family</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">family</span><span class="strut">&nbsp;</span></p>
<p id="t158" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t159" class="stm mis">        <span class="key">if</span> <span class="nam">family</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t160" class="stm mis">            <span class="key">return</span> <span class="nam">str</span><span class="op">(</span><span class="op">(</span><span class="nam">family</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">address</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t161" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t162" class="stm mis">            <span class="key">return</span> <span class="nam">str</span><span class="op">(</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">type</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">value</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t163" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t164" class="stm run hide_run">    <span class="op">@</span><span class="nam">property</span><span class="strut">&nbsp;</span></p>
<p id="t165" class="pln">    <span class="key">def</span> <span class="nam">family</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t166" class="stm mis">        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">==</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">AddressType</span><span class="op">.</span><span class="nam">IPv4</span><span class="op">.</span><span class="nam">value</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t167" class="stm mis">            <span class="key">return</span> <span class="nam">socket</span><span class="op">.</span><span class="nam">AF_INET</span><span class="strut">&nbsp;</span></p>
<p id="t168" class="stm mis">        <span class="key">elif</span> <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">==</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">AddressType</span><span class="op">.</span><span class="nam">IPv4</span><span class="op">.</span><span class="nam">value</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t169" class="stm mis">            <span class="key">return</span> <span class="nam">socket</span><span class="op">.</span><span class="nam">AF_INET6</span><span class="strut">&nbsp;</span></p>
<p id="t170" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t171" class="stm mis">            <span class="key">return</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t172" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t173" class="stm run hide_run">    <span class="op">@</span><span class="nam">property</span><span class="strut">&nbsp;</span></p>
<p id="t174" class="pln">    <span class="key">def</span> <span class="nam">address</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t175" class="stm mis">        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">==</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">AddressType</span><span class="op">.</span><span class="nam">IPv4</span><span class="op">.</span><span class="nam">value</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t176" class="stm mis">            <span class="key">return</span> <span class="nam">socket</span><span class="op">.</span><span class="nam">inet_pton</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">family</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t177" class="stm mis">        <span class="key">elif</span> <span class="nam">self</span><span class="op">.</span><span class="nam">type</span> <span class="op">==</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">AddressType</span><span class="op">.</span><span class="nam">IPv4</span><span class="op">.</span><span class="nam">value</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t178" class="stm mis">            <span class="key">return</span> <span class="nam">socket</span><span class="op">.</span><span class="nam">inet_pton</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">family</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t179" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t180" class="stm mis">            <span class="key">return</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t181" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t182" class="stm run hide_run">    <span class="key">def</span> <span class="nam">encode</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t183" class="pln">        <span class="com"># ipv4-mapped ipv6 addresses must be encoded as ipv4.</span><span class="strut">&nbsp;</span></p>
<p id="t184" class="stm mis">        <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t185" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t186" class="stm run hide_run"><span class="key">class</span> <span class="nam">EncryptedData</span><span class="op">(</span><span class="nam">object</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t187" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t188" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">etype</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t189" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">kvno</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t190" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">ciphertext</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t191" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t192" class="stm run hide_run">    <span class="key">def</span> <span class="nam">from_asn1</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t193" class="stm run hide_run">        <span class="nam">data</span> <span class="op">=</span> <span class="nam">_asn1_decode</span><span class="op">(</span><span class="nam">data</span><span class="op">,</span> <span class="nam">asn1</span><span class="op">.</span><span class="nam">EncryptedData</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t194" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">etype</span> <span class="op">=</span> <span class="nam">constants</span><span class="op">.</span><span class="nam">EncryptionTypes</span><span class="op">(</span><span class="nam">data</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="str">'etype'</span><span class="op">)</span><span class="op">)</span><span class="op">.</span><span class="nam">value</span><span class="strut">&nbsp;</span></p>
<p id="t195" class="stm run hide_run">        <span class="nam">kvno</span> <span class="op">=</span> <span class="nam">data</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="str">'kvno'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t196" class="stm par run hide_run"><span class="annotate short">196&#x202F;&#x219B;&#x202F;197</span><span class="annotate long">line 196 didn't jump to line 197, because the condition on line 196 was never true</span>        <span class="key">if</span> <span class="op">(</span><span class="nam">kvno</span> <span class="key">is</span> <span class="key">None</span><span class="op">)</span> <span class="key">or</span> <span class="op">(</span><span class="nam">kvno</span><span class="op">.</span><span class="nam">hasValue</span><span class="op">(</span><span class="op">)</span> <span class="key">is</span> <span class="key">False</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t197" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">kvno</span> <span class="op">=</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t198" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t199" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">kvno</span> <span class="op">=</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t200" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">ciphertext</span> <span class="op">=</span> <span class="nam">str</span><span class="op">(</span><span class="nam">data</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="str">'cipher'</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t201" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="strut">&nbsp;</span></p>
<p id="t202" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t203" class="stm run hide_run">    <span class="key">def</span> <span class="nam">to_asn1</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">component</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t204" class="stm run hide_run">        <span class="nam">component</span><span class="op">.</span><span class="nam">setComponentByName</span><span class="op">(</span><span class="str">'etype'</span><span class="op">,</span> <span class="nam">int</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">etype</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t205" class="stm par run hide_run"><span class="annotate short">205&#x202F;&#x219B;&#x202F;207</span><span class="annotate long">line 205 didn't jump to line 207, because the condition on line 205 was never false</span>        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">kvno</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t206" class="stm run hide_run">            <span class="nam">component</span><span class="op">.</span><span class="nam">setComponentByName</span><span class="op">(</span><span class="str">'kvno'</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">kvno</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t207" class="stm run hide_run">        <span class="nam">component</span><span class="op">.</span><span class="nam">setComponentByName</span><span class="op">(</span><span class="str">'cipher'</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">ciphertext</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t208" class="stm run hide_run">        <span class="key">return</span> <span class="nam">component</span><span class="strut">&nbsp;</span></p>
<p id="t209" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t210" class="stm run hide_run"><span class="key">class</span> <span class="nam">Ticket</span><span class="op">(</span><span class="nam">object</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t211" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t212" class="pln">        <span class="com"># This is the kerberos version, not the service principal key</span><span class="strut">&nbsp;</span></p>
<p id="t213" class="pln">        <span class="com"># version number.</span><span class="strut">&nbsp;</span></p>
<p id="t214" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">tkt_vno</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t215" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">service_principal</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t216" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">encrypted_part</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t217" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t218" class="stm run hide_run">    <span class="key">def</span> <span class="nam">from_asn1</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">data</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t219" class="stm run hide_run">        <span class="nam">data</span> <span class="op">=</span> <span class="nam">_asn1_decode</span><span class="op">(</span><span class="nam">data</span><span class="op">,</span> <span class="nam">asn1</span><span class="op">.</span><span class="nam">Ticket</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t220" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">tkt_vno</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">data</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="str">'tkt-vno'</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t221" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">service_principal</span> <span class="op">=</span> <span class="nam">Principal</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t222" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">service_principal</span><span class="op">.</span><span class="nam">from_asn1</span><span class="op">(</span><span class="nam">data</span><span class="op">,</span> <span class="str">'realm'</span><span class="op">,</span> <span class="str">'sname'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t223" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">encrypted_part</span> <span class="op">=</span> <span class="nam">EncryptedData</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t224" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">encrypted_part</span><span class="op">.</span><span class="nam">from_asn1</span><span class="op">(</span><span class="nam">data</span><span class="op">.</span><span class="nam">getComponentByName</span><span class="op">(</span><span class="str">'enc-part'</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t225" class="stm run hide_run">        <span class="key">return</span> <span class="nam">self</span><span class="strut">&nbsp;</span></p>
<p id="t226" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t227" class="stm run hide_run">    <span class="key">def</span> <span class="nam">to_asn1</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">component</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t228" class="stm run hide_run">        <span class="nam">component</span><span class="op">.</span><span class="nam">setComponentByName</span><span class="op">(</span><span class="str">'tkt-vno'</span><span class="op">,</span> <span class="num">5</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t229" class="stm run hide_run">        <span class="nam">component</span><span class="op">.</span><span class="nam">setComponentByName</span><span class="op">(</span><span class="str">'realm'</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">service_principal</span><span class="op">.</span><span class="nam">realm</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t230" class="stm run hide_run">        <span class="nam">asn1</span><span class="op">.</span><span class="nam">seq_set</span><span class="op">(</span><span class="nam">component</span><span class="op">,</span> <span class="str">'sname'</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t231" class="pln">                     <span class="nam">self</span><span class="op">.</span><span class="nam">service_principal</span><span class="op">.</span><span class="nam">components_to_asn1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t232" class="stm run hide_run">        <span class="nam">asn1</span><span class="op">.</span><span class="nam">seq_set</span><span class="op">(</span><span class="nam">component</span><span class="op">,</span> <span class="str">'enc-part'</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">encrypted_part</span><span class="op">.</span><span class="nam">to_asn1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t233" class="stm run hide_run">        <span class="key">return</span> <span class="nam">component</span><span class="strut">&nbsp;</span></p>
<p id="t234" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t235" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__str__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t236" class="stm mis">        <span class="key">return</span> <span class="str">"&lt;Ticket for %s vno %s>"</span> <span class="op">%</span> <span class="op">(</span><span class="nam">str</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">service_principal</span><span class="op">)</span><span class="op">,</span> <span class="nam">str</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">encrypted_part</span><span class="op">.</span><span class="nam">kvno</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t237" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t238" class="stm run hide_run"><span class="key">class</span> <span class="nam">KerberosTime</span><span class="op">(</span><span class="nam">object</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t239" class="stm run hide_run">    <span class="nam">INDEFINITE</span> <span class="op">=</span> <span class="nam">datetime</span><span class="op">.</span><span class="nam">datetime</span><span class="op">(</span><span class="num">1970</span><span class="op">,</span> <span class="num">1</span><span class="op">,</span> <span class="num">1</span><span class="op">,</span> <span class="num">0</span><span class="op">,</span> <span class="num">0</span><span class="op">,</span> <span class="num">0</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t240" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t241" class="stm run hide_run">    <span class="op">@</span><span class="nam">staticmethod</span><span class="strut">&nbsp;</span></p>
<p id="t242" class="pln">    <span class="key">def</span> <span class="nam">to_asn1</span><span class="op">(</span><span class="nam">dt</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t243" class="pln">        <span class="com"># A KerberosTime is really just a string, so we can return a</span><span class="strut">&nbsp;</span></p>
<p id="t244" class="pln">        <span class="com"># string here, and the asn1 library will convert it correctly.</span><span class="strut">&nbsp;</span></p>
<p id="t245" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t246" class="stm run hide_run">        <span class="key">return</span> <span class="str">"%04d%02d%02d%02d%02d%02dZ"</span> <span class="op">%</span> <span class="op">(</span><span class="nam">dt</span><span class="op">.</span><span class="nam">year</span><span class="op">,</span> <span class="nam">dt</span><span class="op">.</span><span class="nam">month</span><span class="op">,</span> <span class="nam">dt</span><span class="op">.</span><span class="nam">day</span><span class="op">,</span> <span class="nam">dt</span><span class="op">.</span><span class="nam">hour</span><span class="op">,</span> <span class="nam">dt</span><span class="op">.</span><span class="nam">minute</span><span class="op">,</span> <span class="nam">dt</span><span class="op">.</span><span class="nam">second</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t247" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t248" class="stm run hide_run">    <span class="op">@</span><span class="nam">staticmethod</span><span class="strut">&nbsp;</span></p>
<p id="t249" class="pln">    <span class="key">def</span> <span class="nam">from_asn1</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t250" class="stm mis">        <span class="nam">data</span> <span class="op">=</span> <span class="nam">str</span><span class="op">(</span><span class="nam">data</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t251" class="stm mis">        <span class="nam">year</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">data</span><span class="op">[</span><span class="num">0</span><span class="op">:</span><span class="num">4</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t252" class="stm mis">        <span class="nam">month</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">data</span><span class="op">[</span><span class="num">4</span><span class="op">:</span><span class="num">6</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t253" class="stm mis">        <span class="nam">day</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">data</span><span class="op">[</span><span class="num">6</span><span class="op">:</span><span class="num">8</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t254" class="stm mis">        <span class="nam">hour</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">data</span><span class="op">[</span><span class="num">8</span><span class="op">:</span><span class="num">10</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t255" class="stm mis">        <span class="nam">minute</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">data</span><span class="op">[</span><span class="num">10</span><span class="op">:</span><span class="num">12</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t256" class="stm mis">        <span class="nam">second</span> <span class="op">=</span> <span class="nam">int</span><span class="op">(</span><span class="nam">data</span><span class="op">[</span><span class="num">12</span><span class="op">:</span><span class="num">14</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t257" class="stm mis">        <span class="key">if</span> <span class="nam">data</span><span class="op">[</span><span class="num">14</span><span class="op">]</span> <span class="op">!=</span> <span class="str">'Z'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t258" class="stm mis">            <span class="key">raise</span> <span class="nam">KerberosException</span><span class="op">(</span><span class="str">"timezone in KerberosTime is not Z"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t259" class="stm mis">        <span class="key">return</span> <span class="nam">datetime</span><span class="op">.</span><span class="nam">datetime</span><span class="op">(</span><span class="nam">year</span><span class="op">,</span> <span class="nam">month</span><span class="op">,</span> <span class="nam">day</span><span class="op">,</span> <span class="nam">hour</span><span class="op">,</span> <span class="nam">minute</span><span class="op">,</span> <span class="nam">second</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t260" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t261" class="stm par run hide_run"><span class="annotate short">261&#x202F;&#x219B;&#x202F;263</span><span class="annotate long">line 261 didn't jump to line 263, because the condition on line 261 was never true</span><span class="key">if</span> <span class="nam">__name__</span> <span class="op">==</span> <span class="str">'__main__'</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t262" class="pln">    <span class="com"># TODO marc: turn this into a real test</span><span class="strut">&nbsp;</span></p>
<p id="t263" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="str">"marc"</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t264" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="op">(</span><span class="str">"marc"</span><span class="op">,</span> <span class="key">None</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t265" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="op">(</span><span class="op">(</span><span class="str">"marc"</span><span class="op">,</span><span class="op">)</span><span class="op">,</span> <span class="key">None</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t266" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="str">"marc@ATHENA.MIT.EDU"</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t267" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="str">"marc"</span><span class="op">,</span> <span class="nam">default_realm</span><span class="op">=</span><span class="str">"ATHENA.MIT.EDU"</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t268" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="str">"marc@ATHENA.MIT.EDU"</span><span class="op">,</span> <span class="nam">default_realm</span><span class="op">=</span><span class="str">"EXAMPLE.COM"</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t269" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="op">(</span><span class="str">"marc"</span><span class="op">,</span> <span class="str">"ATHENA.MIT.EDU"</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t270" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="op">(</span><span class="op">(</span><span class="str">"marc"</span><span class="op">)</span><span class="op">,</span> <span class="str">"ATHENA.MIT.EDU"</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t271" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="str">"marc/root"</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t272" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="op">(</span><span class="str">"marc"</span><span class="op">,</span> <span class="str">"root"</span><span class="op">,</span> <span class="str">"ATHENA.MIT.EDU"</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t273" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="op">(</span><span class="op">(</span><span class="str">"marc"</span><span class="op">,</span> <span class="str">"root"</span><span class="op">)</span><span class="op">,</span> <span class="str">"ATHENA.MIT.EDU"</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t274" class="stm mis">    <span class="nam">print</span><span class="op">(</span><span class="nam">Principal</span><span class="op">(</span><span class="str">"marc\\/root"</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
